#pragma once

#include <Base_Configurator.h>

namespace inaf::oasbo::Configurators {

/**
 * @brief The CLConfigurator class is a concrete implementation of the BaseConfigurator class.
 *        It provides functionality to read and push configurations from/to a source using command line arguments (--param1 --param2 and so on).
 * 	  Check the Base_Configurator.h file for more information.
 */
class CLConfigurator: public BaseConfigurator {
protected:
	int argc; /**< The number of command line arguments. */
	char **argv; /**< The array of command line arguments. */

public:
	/**
	 * @brief Constructs a CLConfigurator object with the specified command line arguments.
	 * @param argc The number of command line arguments.
	 * @param argv The array of command line arguments.
	 */
	CLConfigurator(int argc, char **argv);

	int readConfigFromSource() override;

	int readConfigFromSource(std::string target) override;

	int pushConfigToSource() override;

	int pushConfigToSource(std::string target) override;

	int insert(std::map<std::string, std::string>, std::string target) override;

	~CLConfigurator() {
	}

};
}
